<%@ page language="C#" masterpagefile="~/MasterPage.master" autoeventwireup="true" inherits="User_CurrStat, App_Web_tz1saedf" title="Untitled Page" %>
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" Runat="Server">
<asp:HiddenField runat="server" ID="hfMaxRx" Value="1" />
<asp:HiddenField runat="server" ID="hfMaxTx" Value="1" />
    <asp:XmlDataSource ID="dsRepNetStat" runat="server" EnableCaching="False">
        <Transform>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
 <xsl:template match="/">
  <table>
   <xsl:apply-templates select="NetStatList"/>
  </table>
 </xsl:template>
  <xsl:template match="NetStat">
   <Row> 
    <xsl:attribute name="ProtoInfo">
     <xsl:value-of select="@IPProto"/>
    </xsl:attribute>
    <xsl:attribute name="NetStatLog_Rx">
     <xsl:value-of select="@RxBytes"/>
    </xsl:attribute>
    <xsl:attribute name="NetStatLog_Tx">
     <xsl:value-of select="@TxBytes"/>
    </xsl:attribute>
    <xsl:attribute name="NetStatLog_Cost">
     <xsl:value-of select="@RxCost"/>
    </xsl:attribute>
    <xsl:attribute name="TxCost">
     <xsl:value-of select="@TxCost"/>
    </xsl:attribute>
    <xsl:attribute name="HTTPHost">
     <xsl:value-of select="@HTTPHost"/>
    </xsl:attribute>
    <xsl:attribute name="Host">
     <xsl:value-of select="@Host"/>
    </xsl:attribute>
    <xsl:attribute name="PeerPort">
     <xsl:value-of select="@PeerPort"/>
    </xsl:attribute>
    <xsl:attribute name="PeerIp">
     <xsl:value-of select="@PeerIP"/>
    </xsl:attribute>
    <xsl:attribute name="Direction">
     <xsl:value-of select="@Direction"/>
    </xsl:attribute>
    <xsl:attribute name="LastWrite">
     <xsl:value-of select="@LastWrite"/>
    </xsl:attribute>
    <xsl:attribute name="LastActive">
     <xsl:value-of select="@LastActive"/>
    </xsl:attribute>
   </Row>
  </xsl:template>
</xsl:stylesheet></Transform>
    </asp:XmlDataSource>
<asp:Panel ID="pCurrNetStat" runat="server" align="center">
    <asp:Button ID="btnRefresh" runat="server" CssClass="addbut" Font-Size="Small" OnClick="btnRefresh_Click"/>
    <asp:GridView ID="gvRepNetStat" runat="server" CaptionAlign="Top" DataSourceID="dsRepNetStat" AllowPaging="True"
        CssClass="color" PageSize="25" AutoGenerateColumns="False" CellPadding="2" CellSpacing="2"
        OnRowDataBound="gvRepNetStat_RowDataBound" OnPageIndexChanging="gvRepNetStat_PageIndexChanging" Visible="False">
    <HeaderStyle CssClass="lblue1" />
    <RowStyle CssClass="lblue3" />
    <EmptyDataTemplate>
        <div><%# Resources.tiportal.Rep_EmptyData %></div>
    </EmptyDataTemplate>
    <Columns>
        <asp:TemplateField>
            <HeaderStyle CssClass="lblue" HorizontalAlign="Center"/>
            <ItemStyle CssClass="lblue3" Width="55px"/>
            <ItemTemplate><%--0 Rx/TxPic--%>        
            </ItemTemplate>
        </asp:TemplateField>
        <asp:TemplateField>
            <ItemStyle CssClass="lblue3" />
            <ItemTemplate><%--1 Host--%>        
            </ItemTemplate>
        </asp:TemplateField>
        <asp:BoundField DataField="ProtoInfo" HeaderText="ProtoInfo" SortExpression="ProtoInfo">
            <ItemStyle CssClass="lblue3" />
        </asp:BoundField>
        <asp:BoundField DataField="NetStatLog_Rx" HeaderText="NetStatLog_Rx" SortExpression="NetStatLog_Rx">
            <ItemStyle CssClass="lblue3" />
        </asp:BoundField>
        <asp:BoundField DataField="NetStatLog_Tx" HeaderText="NetStatLog_Tx" SortExpression="NetStatLog_Tx">
            <ItemStyle CssClass="lblue3" />
        </asp:BoundField>
        <asp:BoundField DataField="NetStatLog_Cost" HeaderText="NetStatLog_Cost" SortExpression="NetStatLog_Cost">
            <ItemStyle CssClass="lblue3" />
        </asp:BoundField>
        <asp:TemplateField>
            <ItemStyle CssClass="lblue3" />
            <ItemTemplate><%--6 Period--%>        
            </ItemTemplate>
        </asp:TemplateField>
    </Columns>
  </asp:GridView>
</asp:Panel>
</asp:Content>
