﻿// JavaScript Document

function getEasyCalendar()
{
	return new eCalendar();
}

function eCalendar ()
{
	this.timeoutId  =	0;
	this.timeout	= 1500;	// Время сколько он проживет без ховера - т.е. будет убит через такое время, как мышка ушла за пределы

	this.date	=	null;
	this.year	=	null;
	this.month	=	null;
	this.day	=	null;

	this.sDate	=	null;
	this.sYear	=	null;
	this.sMonth	=	null;
	this.sDay	=	null;

	this.pDep	=	null;
	this.pWin	=	null;
	this.pValue	=	null;

	this.isDep	=	false;
	this.isDraw	=	false;
	
	this.sepDate = ".";
	
	this.initDate = function ()
	{
		var inStr = "";
		try
		{
			inStr = this.pValue.value;
		} catch (ex) {;}

		var dP	= inStr.split( this.sepDate );

		var day = 1;
		var month = 0;
		var year = 1900;
		
		if ( dP.length == 3 )
		{
			day = parseInt(dP[0], 10);
			month = parseInt(dP[1], 10) - 1;
			year = parseInt(dP[2], 10);
		} else if ( dP.length == 2 )
		{
			month = parseInt(dP[0], 10) - 1;
			year = parseInt(dP[1], 10);
		} else 
		{ 
			this.date	=	new Date();
			this.year	=	this.date.getFullYear();
			this.month	=	this.date.getMonth();
			this.day	=	this.date.getDate();

			this.sDate	=	new Date();
			this.sYear	=	this.sDate.getFullYear();
			this.sMonth	=	this.sDate.getMonth();
			this.sDay	=	this.sDate.getDate();
            
			return;
		}
        
		this.date	=	new Date( year, month, day );

		this.year	=	this.date.getFullYear();
		this.month	=	this.date.getMonth();
		this.day	=	this.date.getDate();

		this.sDate	=	new Date( year, month, day );
		this.sYear	=	this.sDate.getFullYear();
		this.sMonth	=	this.sDate.getMonth();
		this.sDay	=	this.sDate.getDate();
	}

	this.get2xFormatedInt = function (val)
	{	
		var tmp = new String ( val );
		if (tmp.length == 1) return ("0" + tmp);
		else return tmp;
	}

	this.output = function ()
	{
		this.pValue.value = this.get2xFormatedInt(this.day) + this.sepDate + this.get2xFormatedInt(this.month + 1) + this.sepDate + this.year;
	}
	
	this.getFirstDayOfWeek = function ( Year, Month)
	{
		var dCalDate = new Date(Year, Month - 1, 1);	//this.getCurrentYear( )//this.getCurrentMonth( )
		return dCalDate.getDay();
	}
	
	this.isDrawed = function ()
	{
		return this.isDraw;	
	}
	
	this.isDeployed = function ()
	{
		return this.isDep;
	}

	this.getSDate = function ()
	{
		return this.sDate;	
	}
	
	this.getSYear = function ()
	{
		return this.sYear;	
	}

	this.getSMonth = function ()
	{
		return this.sMonth + 1;
	}

	this.getSMonthName = function ()
	{	
		return getMonthName( this.sMonth );	
	}

	this.getSDay = function ()
    {
		return this.sDay;	
	}

	this.getSDays = function ()
	{
		var dPrevDate = new Date( this.getSYear(), this.getSMonth(), 0);
		return dPrevDate.getDate();
	}

	this.getCurrentYear = function ()
	{
		return this.year;
	}

	this.getCurrentMonthName = function ()
	{
		return getMonthName(this.month);
	}

	this.getCurrentMonth = function ()
	{
		return this.month + 1;	
	}

	this.getCurrentDay = function ()
	{	
		return this.day;		
	}

	this.getCurrentDays = function ()
	{
		var dPrevDate = new Date(this.getCurrentYear(), this.getCurrentMonth(), 0);
		return dPrevDate.getDate();
	}

	this.setDeployer = function (pWin, depId)
	{
		if (typeof(pWin) == "undefined" || pWin == null)
		{
			window.status = "Window object is null";
			return false;
		}
		
		if (typeof(depId) == "undefined" || depId == null)
		{
			window.status = "depId is null";
			return false;
		}
		
		this.pWin = pWin;
		var depElem = pWin.document.getElementById(depId);
		if (typeof(depElem) == "undefined" || depElem == null)
		{
			window.status = "Dep object is null";
			return false;	
		}

		this.pDep = depElem;
		this.isDep = true;
		return true;
	}

	this.updateSDate = function (day, choose)
	{
		this.sDate = new Date( this.getSYear(), this.getSMonth() - 1, day );
		this.sYear	=	this.sDate.getFullYear();
		this.sMonth	=	this.sDate.getMonth();
		this.sDay	=	this.sDate.getDate();

		if (choose)
		{
			this.date = new Date( this.getSYear(), this.getSMonth() - 1, day );
			this.year	=	this.date.getFullYear();
			this.month	=	this.date.getMonth();
			this.day	=	this.date.getDate();
		}
	}

	this.show = function (id)
	{
		if (! this.isDeployed( ) || ! this.isDrawed( ))
		{
			return false;	
		}

		this.pDep.style.visibility = "visible";
	
		if (id != null && id != "")
		{
            //alert(id + ": " + document.getElementById(id)); //my
			this.pValue = document.getElementById(id);
			
/* Позиционируем календарь */
			this.pDep.style.left	= findPosX(this.pValue) + "px"; //Mozilla - px
			this.pDep.style.top		= findPosY(this.pValue) + this.pValue.offsetHeight + 2 + "px"; //Mozilla - px
/* Конец позиционирования */

			this.initDate();
			this.refreshCal();
		}
	}

	this.hide = function ()
	{
		this.pValue = null;

		if (! this.isDeployed( ) || ! this.isDrawed( ))
		{
			return false;	
		}
		this.pDep.style.visibility = "hidden";
	}

	this.hoverEventer = function (oEv)
	{	
		if (oEv == null) oEv = window.event;
		
		switch ( oEv.type )
		{		
			case "mouseover":
				window.clearTimeout(this.timeoutId);
			    break;
			case "mouseout":
				this.timeoutId = window.setTimeout("hidder();", this.timeout);
			    break;
			default:
				return;
			    break;
		}
	}

	this.clickEventer = function (oEv)
	{
		if (oEv == null) oEv = window.event;
		var srcElement = oEv.srcElement || oEv.target;

		if (srcElement.currentStyle)
		{
		    var agt=navigator.userAgent.toLowerCase(); //my
	        //alert("Браузер " + agt); //my
		    if (agt.indexOf("opera") != -1)
		    {
				if ( srcElement.currentStyle.cursor.toUpperCase() != "POINTER"  ) return; //my Opera 9
			}
			else
			{
			    if ( srcElement.currentStyle.cursor.toUpperCase() != "HAND"  ) return; //IE
			}
		} else if (window.getComputedStyle)
		{
			var y = document.defaultView.getComputedStyle(srcElement,null).getPropertyValue("cursor");
			if ( y.toUpperCase() != "POINTER" ) return;	
		}

		switch ( srcElement.className )
		{	
			case "prevMonth":
				if (this.getSMonth( ) == 1)
				{
					this.sMonth = 11;
					--this.sYear;
				} else
				{
					--this.sMonth;
				}
				
				this.updateSDate(1);
				this.refreshCal();
			    break;
			case "nextMonth":
				if ( this.getSMonth( ) == 12 )
				{
					this.sMonth = 0;
					++this.sYear;
	
				} else
				{
					++this.sMonth;
				}

				this.updateSDate(1);
				this.refreshCal();
			    break;
			case "prevYear":
				--this.sYear;
				this.updateSDate(1);
				this.refreshCal();
			    break;
			case "nextYear":
				++this.sYear;
				this.updateSDate(1);
				this.refreshCal();
			    break;
			default:
				this.sDay = srcElement.innerHTML;
				this.updateSDate( this.getSDay( ), true );
				try
				{
					this.output( );
//					this.pValue.value = this.getSDate();              
				} catch (ex) {;}

				this.hide();
			    break;
		}
	}

	this.refreshCal = function ()
	{
		if ( ! this.isDeployed( ) || ! this.isDrawed( ))
		{
			return false;	
		}

		var oTable = this.pWin.document.getElementById( "eCalTable" );
		var oTable2 = this.pWin.document.getElementById( "eCalHTable" );

		try
		{
			var fc = oTable.firstChild;
			oTable.removeChild( fc );
			fc = oTable2.firstChild;
			oTable2.removeChild( fc );
		} catch (ex)
		{	
			// Просто он еще не создан	
		}


		var cR = 0;
		var cC = 0;

		var oTR       =	oTable2.insertRow( cR++ ); 
		oTR.className = "currentDate";

		var oTD = oTR.insertCell( cC++ );
		oTD.className = "prevMonth";
		oTD.innerHTML = "&lt;";

		oTD = oTR.insertCell( cC++ );
		oTD.setAttribute( "width", "50px" );
		oTD.setAttribute( "id", "topNA" );
		oTD.innerHTML = this.getSMonthName();

		oTD = oTR.insertCell( cC++ );
		oTD.className = "nextMonth";
		oTD.innerHTML = "&gt;";

		oTD = oTR.insertCell( cC++ );
		oTD.className = "prevYear";
		oTD.innerHTML = "&lt;";

		oTD = oTR.insertCell( cC++ );
		oTD.setAttribute( "id", "topNA" );
		oTD.innerHTML = this.getSYear();

		oTD = oTR.insertCell( cC++ );
		oTD.className = "nextYear";
		oTD.innerHTML = "&gt;";

		cR = 0;
		oTR	=	oTable.insertRow( cR++ ); 
		cC = 0;
		oTR.className = "header";

		for ( var i = 1; i <= 7; ++i )
		{
			oTD = oTR.insertCell( cC++ );
			oTD.className = i;
			oTD.innerHTML = getWeekDayName( i );
		}

		var j = this.getFirstDayOfWeek( this.getSYear( ), this.getSMonth() );

		if ( j < 1 || j > 7 ) j = 1;
		
		var i = 0;
		var j7	=	1;

		oTR	=	oTable.insertRow( cR++ );
		cC = 0;
		oTR.className = "data";

		for ( i = 1; i < j; ++i )
		{
			oTD = oTR.insertCell( cC++ );
			oTD.className = "empty";
			oTD.innerHTML = "&nbsp;";
			++j7;
		}

		for ( i = 1; i <= this.getSDays( ); ++i )
		{
			oTD = oTR.insertCell( cC++ );
			oTD.innerHTML = i;
			oTD.className = "d" + j7;
			
			if ( i == this.getCurrentDay( ) && this.getCurrentMonth() == this.getSMonth() && this.getCurrentYear() == this.getSYear() )
			{
				oTD.setAttribute( "id", "today" );
			}

			if ((( i + j - 1) % 7 ) == 0 )
			{
				cC = 0;
				oTR	=	oTable.insertRow( cR++ );
				oTR.className = "data";
				j7 = 0;
			}
			
			++j7;
		}

		for ( ; (( i + j - 2) % 7 ) != 0; ++i )
		{
			oTD = oTR.insertCell( cC++ );
			oTD.className = "empty";
			oTD.innerHTML = "&nbsp";
		}

		return true;
	}

	this.drawCal	=	function ( )
	{
		if ( ! this.isDeployed( ))
		{
			return false;	
		}

		var cR = 0;
		var cC = 0;

		var oTable2 = this.pWin.document.createElement( "table" );
		oTable2.className = "eCal";
		oTable2.setAttribute( "id", "eCalHTable" );

		oTable2.onclick		=	onClickEventer;
		oTable2.onmouseover	=	onHoverEventer;
		oTable2.onmouseout	=	onHoverEventer;
		oTable2.onselectstart =	onSelectStart;

		this.pDep.appendChild( oTable2 );

		var oTable = this.pWin.document.createElement( "table" );
		oTable.className = "eCal";
		oTable.setAttribute( "id", "eCalTable" );

		oTable.onclick		=	onClickEventer;
		oTable.onmouseover	=	onHoverEventer;
		oTable.onmouseout	=	onHoverEventer;
		oTable.onselectstart =	onSelectStart;

		this.pDep.appendChild( oTable );
		
		this.isDraw = true;
		this.refreshCal();

		return true;
	}
}

function onSelectStart ()
{	
	return false;	
}

function onClickEventer ( event )
{
	eCal.clickEventer( event );
}

function onHoverEventer( event )
{
	eCal.hoverEventer( event );
}

function hidder ()
{
	eCal.hide();
}


function getWeekDayName ( i )
{	
	switch ( i )
	{
		case 1:
			return "пн";
		    break;
		case 2:
			return "вт";
		    break;
		case 3:
			return "ср";
		    break;
		case 4:
			return "чт";
		    break;
		case 5:
			return "пт";
		    break;
		case 6:
			return "сб";
		    break;
		case 7:
			return "вс";
		    break;
	}
}

function getMonthName ( i )
{
	switch ( i )
	{	
		case 0:
			return "январь";
		    break;
		case 1:
			return "февраль";
		    break;
		case 2:
			return "март";
		    break;
		case 3:
			return "апрель";
		    break;
		case 4:
			return "май";
		    break;
		case 5:
			return "июнь";
		    break;
		case 6:
			return "июль";
		    break;
		case 7:
			return "август";
		    break;
		case 8:
			return "сентябрь";
		    break;
		case 9:
			return "октябрь";
		    break;
		case 10:
			return "ноябрь";
		    break;
		case 11:
			return "декабрь";
		    break;
	}
}

function findPosX(obj)
{
	var curleft = 0;
	if (obj.offsetParent)
	{
		while (obj.offsetParent)
		{
			curleft += obj.offsetLeft
			obj = obj.offsetParent;
		}
	}
	else if (obj.x)
		curleft += obj.x;
	return curleft;
}

function findPosY(obj)
{
	var curtop = 0;
	if (obj.offsetParent)
	{
		while (obj.offsetParent)
		{
			curtop += obj.offsetTop
			obj = obj.offsetParent;
		}
	}
	else if (obj.y)
		curtop += obj.y;
	return curtop;
}
