<%@ page language="C#" masterpagefile="~/MasterPage.master" autoeventwireup="true" inherits="Admin_CurrStat, App_Web_loax5wbn" title="Untitled Page" %>

<%--<%@ Register Assembly="ZedGraph.Web" Namespace="ZedGraph.Web" TagPrefix="cc2" %>--%>

<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" Runat="Server">
<div align="center" class="lbtitle">
    <asp:Label ID="lblNoInfo" runat="server" Visible="False" CssClass="lbtitle" Font-Bold="True" Font-Size="Larger" ForeColor="Gray" EnableViewState="false" />
<ajaxToolkit:ToolkitScriptManager runat="Server" EnablePartialRendering="false" ID="ScriptManager1" />
   <asp:Panel ID="pnlParamHeader" runat="server" CssClass="collapsePanelHeader" Height="30px"> 
        <div style="padding:5px; cursor: pointer; vertical-align: middle;">
            <div style="float:left; vertical-align: middle;">
                <asp:ImageButton ID="imgParam" runat="server" ImageUrl="~/Images/collapse.jpg" />
                <asp:Label ID="lblParam" runat="server" />
            </div>
        </div>
    </asp:Panel>
    <asp:Panel ID="pnlParam" runat="server" CssClass="collapsePanel">
        <table align="center" class="color" cellpadding="2" cellspacing="2">
        <tr>
            <td class="lgray1" align="right"><asp:Label ID="lblTypeRepTitle" runat="server"/></td>
            <td colspan="2" class="lgray2l">
                <asp:DropDownList ID="ddListTypeRep" runat="server" AutoPostBack="True" OnSelectedIndexChanged="ddlTypeRep_Index_Changed"></asp:DropDownList>
            </td>
        </tr>
        <tr>
	        <td class="lgray1" align="right"><asp:Label ID="lblList2Title" runat="server"/></td>
            <td colspan="2" class="lgray2l">
                <asp:DropDownList ID="ddList2" runat="server"></asp:DropDownList>
            </td>
        </tr>
        </table>
    </asp:Panel>
    <ajaxToolkit:CollapsiblePanelExtender ID="cpePanel" runat="Server"
        TargetControlID="pnlParam"
        ExpandControlID="pnlParamHeader"
        CollapseControlID="pnlParamHeader" 
        Collapsed="False"
        ImageControlID="imgParam"    
        ExpandedImage="~/images/collapse.jpg"
        CollapsedImage="~/images/expand.jpg"
        SuppressPostBack="true" />
</div>
<div align="center">
    <asp:Button ID="btnRefresh" runat="server" CssClass="addbut" Font-Size="Small" OnClick="btnRefresh_Click" Visible="False" CausesValidation="False" />
</div>
<%--<asp:HiddenField runat="server" ID="hfRepType"/>--%>
<asp:HiddenField runat="server" ID="hfMaxRx" Value="1" />
<asp:HiddenField runat="server" ID="hfMaxTx" Value="1" />
<asp:HiddenField runat="server" ID="gsView" Value="svTable" />
<asp:XmlDataSource ID="dsRepNetStat" runat="server" EnableCaching="False">
<Transform>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
 <xsl:template match="/">
  <table>
   <xsl:apply-templates select="NetStatList"/>
  </table>
 </xsl:template>
  <xsl:template match="NetStat">
   <Row> 
    <xsl:attribute name="ProtoInfo">
     <xsl:value-of select="@IPProto"/>
    </xsl:attribute>
    <xsl:attribute name="NetStatLog_Rx">
     <xsl:value-of select="@RxBytes"/>
    </xsl:attribute>
    <xsl:attribute name="NetStatLog_Tx">
     <xsl:value-of select="@TxBytes"/>
    </xsl:attribute>
    <xsl:attribute name="NetStatLog_Cost">
     <xsl:value-of select="@RxCost"/>
    </xsl:attribute>
    <xsl:attribute name="TxCost">
     <xsl:value-of select="@TxCost"/>
    </xsl:attribute>
    <xsl:attribute name="HTTPHost">
     <xsl:value-of select="@HTTPHost"/>
    </xsl:attribute>
    <xsl:attribute name="Host">
     <xsl:value-of select="@Host"/>
    </xsl:attribute>
    <xsl:attribute name="PeerPort">
     <xsl:value-of select="@PeerPort"/>
    </xsl:attribute>
    <xsl:attribute name="PeerIp">
     <xsl:value-of select="@PeerIP"/>
    </xsl:attribute>
    <xsl:attribute name="Direction">
     <xsl:value-of select="@Direction"/>
    </xsl:attribute>
    <xsl:attribute name="NetStatLog_ObjectName">
     <xsl:value-of select="@ObjName"/>
    </xsl:attribute>
    <xsl:attribute name="LastWrite">
     <xsl:value-of select="@LastWrite"/>
    </xsl:attribute>
    <xsl:attribute name="LastActive">
     <xsl:value-of select="@LastActive"/>
    </xsl:attribute>
   </Row>
  </xsl:template>
</xsl:stylesheet></Transform>
</asp:XmlDataSource>
<asp:Panel ID="pCurrNetStat" runat="server" align="center">
  <asp:GridView ID="gvRepNetStat" runat="server" CaptionAlign="Top" DataSourceID="dsRepNetStat" AllowPaging="True"
  CssClass="color" PageSize="25" AutoGenerateColumns="False" CellPadding="2" CellSpacing="2"
  OnRowDataBound="gvRepNetStat_RowDataBound" OnPageIndexChanging="gvRepNetStat_PageIndexChanging" Visible="False">
    <HeaderStyle CssClass="lblue1" />
    <RowStyle CssClass="lblue3" />
    <EmptyDataTemplate>
        <div><%# Resources.tiportal.Rep_EmptyData %></div>
    </EmptyDataTemplate>
    <Columns>
        <asp:TemplateField>
            <HeaderStyle CssClass="lblue" HorizontalAlign="Center"/>
            <ItemStyle CssClass="lblue3" Width="55px"/>
            <ItemTemplate><%--0 Rx/TxPic--%>        
            </ItemTemplate>
        </asp:TemplateField>
        <asp:TemplateField>
            <ItemStyle CssClass="lblue3" />
            <ItemTemplate><%--1 Host--%>        
            </ItemTemplate>
        </asp:TemplateField>
        <asp:BoundField DataField="ProtoInfo" HeaderText="ProtoInfo" SortExpression="ProtoInfo">
            <ItemStyle CssClass="lblue3" />
        </asp:BoundField>
        <asp:BoundField DataField="NetStatLog_Rx" HeaderText="NetStatLog_Rx" SortExpression="NetStatLog_Rx">
            <ItemStyle CssClass="lblue3" />
        </asp:BoundField>
        <asp:BoundField DataField="NetStatLog_Tx" HeaderText="NetStatLog_Tx" SortExpression="NetStatLog_Tx">
            <ItemStyle CssClass="lblue3" />
        </asp:BoundField>
        <asp:BoundField DataField="NetStatLog_Cost" HeaderText="NetStatLog_Cost" SortExpression="NetStatLog_Cost">
            <ItemStyle CssClass="lblue3" />
        </asp:BoundField>
         <asp:BoundField DataField="NetStatLog_ObjectName" HeaderText="NetStatLog_ObjectName"
            SortExpression="NetStatLog_ObjectName">
            <ItemStyle CssClass="lblue3" />
        </asp:BoundField>
       <asp:TemplateField>
            <ItemStyle CssClass="lblue3" />
            <ItemTemplate><%--6 Period--%>        
            </ItemTemplate>
        </asp:TemplateField>
    </Columns>
  </asp:GridView>
    <%--<cc2:ZedGraphWeb ID="ccCS" runat="server"  RenderMode="ImageTag" Visible="False" Width="800" Height="600">
    </cc2:ZedGraphWeb>--%>
  </asp:Panel>
</asp:Content>
